package ru.ulstu.fc.rule.controller;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;

import ru.ulstu.fc.rule.model.FuzzyRuleForm;
import ru.ulstu.fc.rule.service.FuzzyRuleService;

@Controller
@RequestMapping("rule")
public class RuleController {
    private final FuzzyRuleService ruleService;

    public RuleController(FuzzyRuleService ruleService) {
        this.ruleService = ruleService;
    }

    @GetMapping("/edit/{projectId}/{ruleId}")
    public String edit(@PathVariable(value = "projectId") Integer projectId,
            @PathVariable(value = "ruleId") Integer id, Model model) {
        model.addAttribute("projectId", projectId);
        model.addAttribute("rule",
                new FuzzyRuleForm(id, (id != null && id != 0)
                        ? ruleService.getById(id).getProject().getId()
                        : projectId));

        return "rule/edit";
    }

    @PostMapping(value = "save", params = "save")
    public String save(FuzzyRuleForm ruleForm, Model model) {
        model.addAttribute("rule", ruleService.save(ruleForm));
        return "redirect:/project/edit/" + ruleForm.getProjectId();
    }

    @PostMapping(value = "save", params = "delete")
    public String delete(FuzzyRuleForm ruleForm) {
        if (ruleForm != null && ruleForm.getId() != null) {
            ruleService.delete(ruleForm);
        }
        return "redirect:/project/edit/" + ruleForm.getProjectId();
    }
}
